winstd::cert_chain_context Class Reference
Cryptography API

PCCERT_CHAIN_CONTEXT wrapper class. More...

`#include <WinStd/Crypt.h>`

Inheritance diagram for winstd::cert_chain_context:

## Public Member Functions

virtual | ~cert_chain_context ()
| Destroys the certificate chain context. More...
bool | create (HCERTCHAINENGINE hChainEngine, PCCERT_CONTEXT pCertContext, LPFILETIME pTime, HCERTSTORE hAdditionalStore, PCERT_CHAIN_PARA pChainPara, DWORD dwFlags, __reserved LPVOID pvReserved=NULL) noexcept
| Creates the certificate chain context. More...
Public Member Functions inherited from winstd::dplhandle< PCCERT_CHAIN_CONTEXT, NULL >
| dplhandle () noexcept
| Initializes a new class instance with the object handle set to INVAL.
| dplhandle (handle_type h) noexcept
| Initializes a new class instance with an already available object handle. More...
| dplhandle (const dplhandle< handle_type, INVAL > &h) noexcept
| Copy constructor. More...
| dplhandle (dplhandle< handle_type, INVAL > &&h) noexcept
| Move constructor. More...
dplhandle< handle_type, INVAL > & | operator= (handle_type h) noexcept
| Attaches already available object handle. More...
dplhandle< handle_type, INVAL > & | operator= (const dplhandle< handle_type, INVAL > &h) noexcept
| Duplicates the object. More...
dplhandle< handle_type, INVAL > & | operator= (dplhandle< handle_type, INVAL > &&h) noexcept
| Moves the object. More...
handle_type | duplicate () const
| Duplicates and returns a new object handle. More...
bool | attach_duplicated (handle_type h)
| Duplicates an object handle and sets a new object handle. More...
Public Member Functions inherited from winstd::handle< PCCERT_CHAIN_CONTEXT, INVAL >
| handle () noexcept
| Initializes a new class instance with the object handle set to INVAL.
| handle (handle_type h) noexcept
| Initializes a new class instance with an already available object handle. More...
| handle (handle< handle_type, INVAL > &&h) noexcept
| Move constructor. More...
handle< handle_type, INVAL > & | operator= (handle_type h) noexcept
| Attaches already available object handle. More...
handle< handle_type, INVAL > & | operator= (handle< handle_type, INVAL > &&h) noexcept
| Move assignment. More...
| operator handle_type () const
| Auto-typecasting operator. More...
handle_type *& | operator* () const
| Returns the object handle value when the object handle is a pointer to a value (class, struct, etc.). More...
handle_type * | operator& ()
| Returns the object handle reference. More...
handle_type | operator-> () const
| Provides object handle member access when the object handle is a pointer to a class or struct. More...
bool | operator! () const
| Tests if the object handle is INVAL. More...
bool | operator< (handle_type h) const
| Is handle less than? More...
bool | operator<= (handle_type h) const
| Is handle less than or equal to? More...
bool | operator>= (handle_type h) const
| Is handle greater than or equal to? More...
bool | operator> (handle_type h) const
| Is handle greater than? More...
bool | operator!= (handle_type h) const
| Is handle not equal to? More...
bool | operator== (handle_type h) const
| Is handle equal to? More...
void | attach (handle_type h) noexcept
| Sets a new object handle for the class. More...
handle_type | detach ()
| Dismisses the object handle from this class. More...
void | free ()
| Destroys the object.

## Protected Member Functions

void | free_internal () noexcept override
| Destroys the certificate chain context. More...
handle_type | duplicate_internal (handle_type h) const noexcept override
| Duplicates the certificate chain context. More...
virtual handle_type | duplicate_internal (handle_type h) const noexcept=0
| Abstract member function that must be implemented by child classes to do the actual object handle duplication. More...
virtual void | free_internal () noexcept=0
| Abstract member function that must be implemented by child classes to do the actual object destruction. More...

## Additional Inherited Members

Public Types inherited from winstd::handle< PCCERT_CHAIN_CONTEXT, INVAL >
typedef PCCERT_CHAIN_CONTEXT | handle_type
| Datatype of the object handle this template class handles.
Static Public Attributes inherited from winstd::handle< PCCERT_CHAIN_CONTEXT, INVAL >
static const PCCERT_CHAIN_CONTEXT | invalid
| Invalid handle value.
Protected Attributes inherited from winstd::handle< PCCERT_CHAIN_CONTEXT, INVAL >
handle_type | m_h
| Object handle.

## Detailed Description

PCCERT_CHAIN_CONTEXT wrapper class.

## Constructor & Destructor Documentation

## ~cert_chain_context()

virtual winstd::cert_chain_context::~cert_chain_context | ( |  | ) |

inlinevirtual

Destroys the certificate chain context.

See also
  CertFreeCertificateChain function

## Member Function Documentation

## create()

bool winstd::cert_chain_context::create | ( | HCERTCHAINENGINE | hChainEngine,
|  | PCCERT_CONTEXT | pCertContext,
|  | LPFILETIME | pTime,
|  | HCERTSTORE | hAdditionalStore,
|  | PCERT_CHAIN_PARA | pChainPara,
|  | DWORD | dwFlags,
|  | __reserved LPVOID | pvReserved = `NULL`
| ) |  |

inlinenoexcept

Creates the certificate chain context.

Returns
  - true when creation succeeds;
  - false when creation fails. For extended error information, call `GetLastError()`.

See also
  CertGetCertificateChain function

## duplicate_internal()

handle_type winstd::cert_chain_context::duplicate_internal | ( | handle_type | h | ) | const

inlineoverrideprotectedvirtualnoexcept

Duplicates the certificate chain context.

Parameters

  [in] | h | Object handle of existing certificate chain context

Returns
  Duplicated certificate chain context handle

See also
  CertDuplicateCertificateContext function

Implements winstd::dplhandle< PCCERT_CHAIN_CONTEXT, NULL >.

## free_internal()

void winstd::cert_chain_context::free_internal | ( |  | ) |

inlineoverrideprotectedvirtualnoexcept

Destroys the certificate chain context.

See also
  CertFreeCertificateChain function

Implements winstd::handle< PCCERT_CHAIN_CONTEXT, INVAL >.

The documentation for this class was generated from the following file:

- include/WinStd/Crypt.h